--$Name: Игра «Жизнь»$
--$Version: 0.3$
--$Author: Андрей Лобанов$

instead_version "1.9.1"

require "sprites"
require "timer"
require "click"
require "kbd"
spr = sprite
click.press = true
first_generation = true
button_press = false

global {
   gworld = {}, -- Глобальные таблицы "мира"
   gworld1 = {},
   evolution = false, -- Флаг эфолюции
   generation = 0,
   population = 0,
   state = false, -- Флаг, отвечающий за переключение между таблицами мира и очередями
   screen_x = 0, -- Координаты левого верхнего угла "экрана"
   screen_y = 0,
   prev_screen_x = 0,
   prev_screen_y = 0,
   gorder = {}, -- Глобальные таблицы очереди
   gorder1 = {},
   zoom = true,
   prev_x = -1,
   prev_y = -1,
   iteration = 0 -- Счётчик для замедления эволюции
}

function init ()
   local i, j, k
   k = 1
   for i = 1, 150 do
      gworld[i] = {}
      gworld1[i] = {}
      for j = 1, 150 do
	 gworld[i][j] = 0
	 gworld1[i][j] = 0
	 k = k + 1
      end
   end
   timer:set(50)
   bg = spr.load 'box:800x600, black'
   bg1 = spr.load 'box:800x600, black'
   spr.fill (bg1, 600, 0, 1, 600, '#222222')
   i = 0
   while (i <= 600) do
      spr.fill (bg, i, 0, 1, 600, '#222222')
      i = i + 10
   end
   i = 0
   while (i <= 600) do
      spr.fill (bg, 0, i, 600, 1, '#222222')
      i = i + 10
   end
   start_button = spr.load 'img/start.png'
   stop_button = spr.load 'img/stop.png'
   turn_button = spr.load 'img/turn.png'
   clear_button = spr.load 'img/clear.png'
   cell = spr.load 'img/cell.png'
   cell1 = spr.load 'img/cell1.png'
   cell2 = spr.load 'box:3x3,#008800'
   cell3 = spr.load 'box:3x3,#00BB00'
   zoom_button0 = spr.load 'img/zoom0.png'
   zoom_button1 = spr.load 'img/zoom1.png'
   font = spr.font ('DroidSans.ttf', 14);
   font_height = spr.font_height (font)
   hook_keys ('space', 'return', 'c', 'up', 'right', 'down' ,'left', 'n', '1', '2')
end

function cell_exist (ord, x, y)
   local k, v, t
   t = false
   for k, v in ipairs (ord) do
      if x == v.x and y == v.y then
	 t = true
      end
   end
   return t
end

function neighborhood (world, i, j)
   local n
   n = 0
   
   if i > 1 and j > 1 and world[i - 1][j - 1] == 1 then
      n = n + 1
   end
   if i == 1 and j > 1 and world[150][j - 1] == 1 then
      n = n + 1
   end
   if i > 1 and j == 1 and world[i - 1][150] == 1 then
      n = n + 1
   end
   if i == 1 and j == 1 and world[150][150] == 1 then
      n = n + 1
   end
   
   if j > 1 and world[i][j - 1] == 1 then
      n = n + 1
   end
   if j == 1 and world[i][150] == 1 then
      n = n + 1
   end

   if i < 150 and j > 1 and world[i + 1][j - 1] == 1 then
      n = n + 1
   end
   if i == 150 and j > 1 and world[1][j - 1] == 1 then
      n = n + 1
   end
   if i < 150 and j == 1 and world[i + 1][150] == 1 then
      n = n + 1
   end
   if i == 150 and j == 1 and world[1][150] == 1 then
      n = n + 1
   end
   
   if i > 1 and world[i - 1][j] == 1 then
      n = n + 1
   end
   if i == 1 and world[150][j] == 1 then
      n = n + 1
   end

   if i < 150 and world[i + 1][j] == 1 then
      n = n + 1
   end
   if i == 150 and world[1][j] == 1 then
      n = n + 1
   end

   if i > 1 and j < 150 and world[i - 1][j + 1] == 1 then
      n = n + 1
   end
   if i == 1 and j < 150 and world[150][j + 1] == 1 then
      n = n + 1
   end
   if i > 1 and j == 150 and world[i - 1][1] == 1 then
      n = n + 1
   end
   if i == 1 and j == 150 and world[150][1] == 1 then
      n = n + 1
   end

   if j < 150 and world[i][j + 1] == 1 then
      n = n + 1
   end
   if j == 150 and world[i][1] == 1 then
      n = n + 1
   end

   if i < 150 and j < 150 and world[i + 1][j + 1] == 1 then
      n = n + 1
   end
   if i == 150 and j < 150 and world[1][j + 1] == 1 then
      n = n + 1
   end
   if i < 150 and j == 150 and world[i + 1][1] == 1 then
      n = n + 1
   end
   if i == 150 and j == 150 and world[1][1] == 1 then
      n = n + 1
   end

   return n
end

function add_to_order (ord, i, j)
   local a, k, v
   a = 1
   for k, v in ipairs (ord) do
      a = a + 1
   end
   if i > 1 and j > 1 then
      ord[a] = {}
      ord[a].x = i - 1
      ord[a].y = j - 1
      a = a + 1
   end
   if i == 1 and j > 1 then
      ord[a] = {}
      ord[a].x = 150
      ord[a].y = j - 1
      a = a + 1
   end
   if i > 1 and j == 1 then
      ord[a] = {}
      ord[a].x = i - 1
      ord[a].y = 150
      a = a + 1
   end
   if i == 1 and j == 1 then
      ord[a] = {}
      ord[a].x = 150
      ord[a].y = 150
      a = a + 1
   end

   if j > 1 then
      ord[a] = {}
      ord[a].x = i
      ord[a].y = j - 1
      a = a + 1
   end
   if j == 1 then
      ord[a] = {}
      ord[a].x = i
      ord[a].y = 150
      a = a + 1
   end

   if i < 150 and j > 1 then
      ord[a] = {}
      ord[a].x = i + 1
      ord[a].y = j - 1
      a = a + 1
   end
   if i == 150 and j > 1 then
      ord[a] = {}
      ord[a].x = 1
      ord[a].y = j - 1
      a = a + 1
   end
   if i < 150 and j == 1 then
      ord[a] = {}
      ord[a].x = i + 1
      ord[a].y = 150
      a = a + 1
   end
   if i == 150 and j == 1 then
      ord[a] = {}
      ord[a].x = 1
      ord[a].y = 150
      a = a + 1
   end

   if i > 1 then
      ord[a] = {}
      ord[a].x = i - 1
      ord[a].y = j
      a = a + 1
   end
   if i == 1 then
      ord[a] = {}
      ord[a].x = 150
      ord[a].y = j
      a = a + 1
   end

   ord[a] = {}
   ord[a].x = i
   ord[a].y = j
   a = a + 1
   
   if i < 150 then
      ord[a] = {}
      ord[a].x = i + 1
      ord[a].y = j
      a = a + 1
   end
   if i == 150 then
      ord[a] = {}
      ord[a].x = 1
      ord[a].y = j
      a = a + 1
   end

   if i > 1 and j < 150 then
      ord[a] = {}
      ord[a].x = i - 1
      ord[a].y = j + 1
      a = a + 1
   end
   if i == 1 and j < 150 then
      ord[a] = {}
      ord[a].x = 150
      ord[a].y = j + 1
      a = a + 1
   end
   if i > 1 and j == 150 then
      ord[a] = {}
      ord[a].x = i - 1
      ord[a].y = 1
      a = a + 1
   end
   if i == 1 and j == 150 then
      ord[a] = {}
      ord[a].x = 150
      ord[a].y = 1
      a = a + 1
   end

   if j < 150 then
      ord[a] = {}
      ord[a].x = i
      ord[a].y = j + 1
      a = a + 1
   end
   if j == 150 then
      ord[a] = {}
      ord[a].x = i
      ord[a].y = 1
      a = a + 1
   end

   if i < 150 and j < 150 then
      ord[a] = {}
      ord[a].x = i + 1
      ord[a].y = j + 1
      a = a + 1
   end
   if i == 150 and j < 150 then
      ord[a] = {}
      ord[a].x = 1
      ord[a].y = j + 1
      a = a + 1
   end
   if i < 150 and j == 150 then
      ord[a] = {}
      ord[a].x = i + 1
      ord[a].y = 1
      a = a + 1
   end
   if i == 150 and j == 150 then
      ord[a] = {}
      ord[a].x = 1
      ord[a].y = 1
      a = a + 1
   end
end

function normalize_order (ord, fi)
   local temp_table, return_table = {}, {}
   local a, b, c = 1, 1, 1
   table.sort (ord, function (a, b) return a.x < b.x end)
   temp_table[1] = {}
   temp_table[1][1] = {}
   temp_table[1][1].x = ord[1].x
   temp_table[1][1].y = ord[1].y
   temp_table[1][1].del = false
   for a, v in ipairs (ord) do
      if v.x == temp_table[b][c].x then
	 c = c + 1
	 temp_table[b][c] = {}
	 temp_table[b][c].x = v.x
	 temp_table[b][c].y = v.y
	 temp_table[b][c].del = false
      else
	 b = b + 1
	 c = 1
	 temp_table[b] = {}
	 temp_table[b][c] = {}
	 temp_table[b][c].x = v.x
	 temp_table[b][c].y = v.y
	 temp_table[b][c].del = false
      end
   end
   for k, v in ipairs (temp_table) do
      table.sort (temp_table[k], function (a, b) return a.y < b.y end)
   end
   for a, v in ipairs (temp_table) do
      for b, v in ipairs (temp_table[a]) do
	 if next (temp_table[a], b) and temp_table[a][b].y == temp_table[a][b + 1].y then
	    temp_table[a][b].del = true
	 end
      end
   end
   c = 0
   if not state and not fi then
      gorder1 = {}
      return_table = gorder1
   else
      gorder = {}
      return_table = gorder
   end
   for a, v in ipairs (temp_table) do
      for b, v in ipairs (temp_table[a]) do
	 if not temp_table[a][b].del then
	    c = c + 1
	    return_table[c] = {}
	    return_table[c].x = v.x
	    return_table[c].y = v.y
	 end
      end
   end
end

function life()
   local world, world1, i, j, n, k, v, change, order, order1
   if not state then
      world, world1 = gworld, gworld1
      gorder1 = {}
      order, order1 = gorder, gorder1
   else
      world, world1 = gworld1, gworld
      gorder = {}
      order, order1 = gorder1, gorder
   end
   if first_generation then
      normalize_order (order, true)
      first_generation = false
   end
   if not state then
      order, order1 = gorder, gorder1
   else
      order, order1 = gorder1, gorder
   end
--   stead.busy (true)
   population = 0
   generation = generation + 1
   for k, v in ipairs (order) do
      n = 0
      change = false
      i = v.x
      j = v.y
      n = neighborhood (world, i, j) 
      if n == 2 and world[i][j] == 1 then
	 world1[i][j] = 1
	 population = population + 1
	 change = true
      elseif n == 3 then
	 world1[i][j] = 1
	 population = population + 1
	 change = true
      elseif (n < 2 or n > 3) and world[i][j] == 1 then
	 world1[i][j] = 0
	 change = true
      elseif n < 2 or n > 3 or (n == 2 and world[i][j] == 0) then
	 world1[i][j] = 0
      end
      if change then
	 add_to_order (order1, i, j)
      end
   end
   if next (order1) then
      normalize_order (order1, false)
   end
   if not state then
      order1 = gorder1
   else
      order1 = gorder
   end
   state = not state
--   stead.busy (false)
end

function clear ()
   local i, j
   evolution = false
   generation = 0
   population = 0
   for i = 1, 150 do
      for j = 1, 150 do
	 gworld[i][j] = 0
	 gworld1[i][j] = 0
	 gorder = {}

	 gorder1 = {}
      end
   end
end

game.click = function (s, press, x, y)
   local i, j, x, y
   if press then
      x, y = stead.mouse_pos ()
      if x >= 605 and x < 635 and y >= 565 and y < 595 then
	 clear()
      elseif x >= 707 and x < 736 and y >= 565 and y < 595 then
	 if zoom then
	    prev_screen_x = screen_x
	    prev_screen_y = screen_y
	    screen_x = 0
	    screen_y = 0
	 else
	    screen_x = prev_screen_x
	    screen_y = prev_screen_y
	 end
	 zoom = not zoom
      elseif x >= 736 and x < 764 and y >= 565 and y < 595 then
	 if not evolution then
	    if not state and next (gorder) or next (gorder1) then
	       evolution = true
	    end
	 else
	    evolution = false
	 end
      elseif x >= 764 and x < 795 and y >= 565 and y < 595 then
	 life ()
      end
      if x < 600 or zoom and x > 624 and x < 775 and y > 2 * font_height + 14 and y < 2 * font_height + 165 then
	 button_press = true
      end
   else
      prev_x = -1
      prev_y = -1
      button_press = false
   end
end

game.kbd = function (s, down, key)
   local i, j, k
   if down then
      if key == 'space' then
	 if not evolution then
	    if not state and next (gorder) or next (gorder1) then
	       evolution = true
	    end
	 else
	    evolution = false
	 end
      elseif key == 'return' then
	 life ()
      elseif key == 'c' then
	 clear ()
      elseif key == 'up' and zoom and screen_y >= 1 then
	 screen_y = screen_y - 1
      elseif key == 'right' and zoom and screen_x <= 89 then
	 screen_x = screen_x + 1
      elseif key == 'down' and zoom and screen_y <= 89 then
	 screen_y = screen_y + 1
      elseif key == 'left' and zoom and screen_x >= 1 then
	 screen_x = screen_x - 1
      elseif key == '1' and zoom then
	 zoom = false
	 prev_screen_x = screen_x
	 prev_screen_y = screen_y
	 screen_x = 0
	 screen_y = 0
      elseif key == '2' and not zoom then
	 zoom = true
	 screen_x = prev_screen_x
	 screen_y = prev_screen_y
      end
   end
end

game.timer = function (s)
   local i, j, x, y, n
   if button_press then
      x, y = stead.mouse_pos ()
      if x < 600 then
	 if zoom then
	    x = math.floor (x / 10) + screen_x
	    y = math.floor (y / 10) + screen_y
	 else
	    x = math.floor (x / 4)
	    y = math.floor (y / 4)
	 end
	 if x ~= prev_x or y ~= prev_y then
	    if not state then
	       if gworld[x + 1][y + 1] == 0 then
		  gworld[x + 1][y + 1] = 1
		  add_to_order (gorder, x + 1, y + 1)
		  population = population + 1
	       else
		  gworld[x + 1][y + 1] = 0
		  population = population - 1
	       end
	    else
	       if gworld1[x + 1][y + 1] == 0 then
		  gworld1[x + 1][y + 1] = 1
		  add_to_order (gorder1, x + 1, y + 1)
		  population = population + 1
	       else
		  gworld1[x + 1][y + 1] = 0
		  population = population - 1
	       end
	    end
	    prev_x = x
	    prev_y = y
	 end
      else
	 x = x - 624
	 y = y - 2 * font_height - 14
	 screen_x = x - 30
	 screen_y = y - 30
	 if screen_x < 0 then
	    screen_x = 0
	 elseif screen_x > 90 then
	    screen_x = 90
	 end
	 if screen_y < 0 then
	    screen_y = 0
	 elseif screen_y > 90 then
	    screen_y = 90
	 end
      end
   end
   if zoom then
      spr.copy (bg, spr.screen(), 0, 0)
   else
      spr.copy (bg1, spr.screen(), 0, 0)
   end
   if zoom then
      n = 60
   else
      n = 150
   end
   for i = 1, n do
      for j = 1, n do
	 if not state then
	    x = gworld[i + screen_x][j + screen_y]
	 else
	    x = gworld1[i + screen_x][j + screen_y]
	 end
	 if x == 1 then
	    if not evolution then
	       if zoom then
		  spr.copy (cell, spr.screen(), i * 10 - 9, j * 10 - 9)
	       else
		  spr.copy (cell2, spr.screen(), i * 4 - 3, j * 4 - 3)
	       end
	    else
	       if zoom then
		  spr.copy (cell1, spr.screen(), i * 10 - 9, j * 10 - 9)
	       else
		  spr.copy (cell3, spr.screen(), i * 4 - 3, j * 4 - 3)
	       end
	    end
	 end
      end
   end
   gen = spr.text (font, 'Поколение: ' .. tostring (generation), '#BBBBBB')
   pop = spr.text (font, 'Популяция: ' .. tostring (population), '#BBBBBB')
   spr.draw (gen, spr.screen(), 605, 2)
   spr.draw (pop, spr.screen(), 605, 2 + font_height)
   spr.free (gen)
   spr.free (pop)
   spr.fill (spr.screen(), 624, 2 * font_height + 14, 151, 1, '#BBBBBB')
   spr.fill (spr.screen(), 624, 2 * font_height + 165, 152, 1, '#BBBBBB')
   spr.fill (spr.screen(), 624, 2 * font_height + 14, 1, 151, '#BBBBBB')
   spr.fill (spr.screen(), 775, 2 * font_height + 14, 1, 151, '#BBBBBB')
   if zoom then
      spr.fill (spr.screen(), 625 + screen_x, 2 * font_height + 15 + screen_y, 60, 60, '#888888')
   end
   spr.draw (clear_button, spr.screen(), 605, 565)
   if not zoom then
      spr.draw (zoom_button0, spr.screen(), 707, 565)
   else
      spr.draw (zoom_button1, spr.screen(), 707, 565)
   end
   if evolution then
      spr.draw (stop_button, spr.screen(), 736, 565)
      if iteration == 2 then
	 life ()
	 iteration = 0
      else
	 iteration = iteration + 1
      end
   else
      spr.draw (start_button, spr.screen(), 736, 565)
   end
   spr.draw (turn_button, spr.screen(), 765, 565)
end
